<?php
/***********************************************************************

  Copyright (C) 2005  Connor Dunn (Connorhd@mypunbb.com)

  This software is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This software is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/
/***********************************************************************

  Copyright (C) 2006 Vin100 (traduction initiale)
  Copyright (C) 2008 MPOK (v2.0)

  Modifications v2 : - rajout du flag "test only"
                     - rajout du flag "afficher info" (dans le cas test only)
                     - changement d'ordre des opérations de ménage
                     - refonte du code (fonctions), léger changement du markup
                     - correction du bug "forums sans discussion" (synchronize_forum_last_post)
                     - correction du bug "utilisateurs sans message" (synchronize_user_posts)
                     - correction du bug "forums sans discussion" (synchronize_forum_posts)
                     - intégration du plugin "Vider le cache" (avec modification pour PunToolBar)

  Plugin de nettoyage des forums.

************************************************************************/

// Make sure no one attempts to run this script "directly"
if (!defined('PUN'))
	exit;

// Tell admin_loader.php that this is indeed a plugin and that it is loaded
define('PUN_PLUGIN_LOADED', 1);
define('PLUGIN_VERSION', '2.0');

// Cleanup spam : delete all users and posts from specified ips, then perform all other cleanup tasks except resetting post counts since that might not be needed or wanted
function cleanup_spam()
{
	global $db;

	@set_time_limit(0);
	if (isset($_POST['ip_addys']) && trim($_POST['ip_addys']) != '')
		$ip = "'".implode("','", array_values(explode(' ', trim($_POST['ip_addys']))))."'";
	else
		$ip = '';
	if ($ip != '')
		if (isset($_POST['test']))
		{
			$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'prov_posts SELECT id, poster, poster_ip, posted, topic_id FROM '.$db->prefix.'posts') or error('Echec de la création de la table provisoire des messages', __FILE__, __LINE__, $db->error());
			$result = $db->query('DELETE FROM '.$db->prefix.'prov_posts WHERE poster_ip IN('.$ip.')') or error('Les messages ne peuvent pas être supprimés (dans la table provisoire)', __FILE__, __LINE__, $db->error());
			$nb_posts = $db->affected_rows($result);
			$mess = 'Nombre de messages à supprimer :<br />- '.$nb_posts.' messages.';
			$result = $db->query('SELECT id FROM '.$db->prefix.'users WHERE registration_ip IN('.$ip.')') or error('Les utilisateurs ne peuvent pas être supprimés (virtuellement)', __FILE__, __LINE__, $db->error());
			$nb_users = $db->num_rows($result);
			$mess .= '<br />Nombre d\'utilisateurs à supprimer :<br />- '.$nb_users.' utilisateurs.';
			$post = 'prov_posts';
		}
		else
		{
			$result = $db->query('DELETE FROM '.$db->prefix.'posts WHERE poster_ip IN('.$ip.')') or error('Les messages ne peuvent pas être supprimés', __FILE__, __LINE__, $db->error());
			$nb_posts = $db->affected_rows($result);
			$mess = 'Nombre de messages supprimés :<br />- '.$nb_posts.' messages.';
			$result = $db->query('DELETE FROM '.$db->prefix.'users WHERE registration_ip IN('.$ip.')') or error('Les utilisateurs ne peuvent pas être supprimés', __FILE__, __LINE__, $db->error());
			$nb_users = $db->affected_rows($result);
			$mess .= '<br />Nombre d\'utilisateurs supprimés :<br />- '.$nb_users.' utilisateurs.';
			$post = 'posts';
		}
	else
	{
		$mess = 'Synchronisation globale :';
		$post = 'posts';
	}
	$mess .= '<br /><br />'.clear_orphans($post);
	$mess .= '<br /><br />'.synchronize_topic_last_post($post);
	$mess .= '<br /><br />'.synchronize_forum_last_post($post);
	$mess .= '<br /><br />'.synchronize_topic_posts($post);
	$mess .= '<br /><br />'.synchronize_forum_posts($post);

	if (!isset($_POST['test']))
		$mess .= '<br /><br />Forums nettoyés.';
	return $mess;
}

// Clear orphans topics / posts
function clear_orphans($post = 'posts')
{
	global $db;

	// Discussions sans message
	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'orph_topic SELECT t.id AS o_id, subject FROM '.$db->prefix.'topics AS t LEFT JOIN '.$db->prefix.$post.' AS p ON p.topic_id = t.id WHERE p.id IS NULL') or error('Echec de la création de la table des discussions orphelines', __FILE__, __LINE__, $db->error());
	if (isset($_POST['test']))
	{
		$result = $db->query('SELECT o_id, subject FROM '.$db->prefix.'orph_topic') or error('Les discussions orphelines (de message) ne peuvent être récupérées', __FILE__, __LINE__, $db->error());
		$nb_orph_topic = $db->num_rows($result);
		$t = array();
		if (isset($_POST['info']))
			while ($topic = $db->fetch_assoc($result))
				$t[] = pun_htmlspecialchars($topic['subject']).' ['.$topic['o_id'].']';
		$mess = 'Orphelins à supprimer :<br />- '.$nb_orph_topic.' discussions';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
	}
	else
	{
		$result = $db->query('DELETE '.$db->prefix.'topics FROM '.$db->prefix.'topics, '.$db->prefix.'orph_topic WHERE o_id=id') or error('Les discussions ne peuvent être supprimées', __FILE__, __LINE__, $db->error());
		$nb_orph_topic = $db->affected_rows($result);
		$mess = 'Orphelins supprimés.<br />- '.$nb_orph_topic.' discussions.';
	}

	// Messages sans discussion
	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'orph_posts SELECT p.id AS o_id FROM '.$db->prefix.$post.' AS p LEFT JOIN '.$db->prefix.'topics t ON p.topic_id=t.id WHERE t.id IS NULL') or error('Echec de la création de la table des messages orphelins', __FILE__, __LINE__, $db->error());
	if (isset($_POST['test']))
	{
		$result = $db->query('SELECT o_id FROM '.$db->prefix.'orph_posts') or error('Les messages orphelins ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
		$nb_orph_post = $db->num_rows($result);
		$t = array();
		if (isset($_POST['info']))
			while ($post = $db->fetch_assoc($result))
				$t[] = $post['o_id'];
		$mess .= '<br />- '.$nb_orph_post.' messages';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
	}
	else
	{
		$result = $db->query('DELETE '.$db->prefix.'posts FROM '.$db->prefix.'posts, '.$db->prefix.'orph_posts WHERE o_id=id') or error('Les messages ne peuvent être supprimés', __FILE__, __LINE__, $db->error());
		$nb_orph_post = $db->affected_rows($result);
		$mess .= '<br />- '.$nb_orph_post.' messages.';
	}

	// Discussions sans forum
	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'orph_topics SELECT t.id AS o_id, subject FROM '.$db->prefix.'topics AS t LEFT JOIN '.$db->prefix.'forums AS f ON t.forum_id=f.id WHERE f.id is NULL') or error('Echec de la création de la table des discussions orphelines', __FILE__, __LINE__, $db->error());
	if (isset($_POST['test']))
	{
		$result = $db->query('SELECT o_id, subject FROM '.$db->prefix.'orph_topics') or error('Les discussions orphelines (de forum) ne peuvent être récupérées', __FILE__, __LINE__, $db->error());
		$nb_orph_forum = $db->num_rows($result);
		$t = array();
		if (isset($_POST['info']))
			while ($topic = $db->fetch_assoc($result))
				$t[] = pun_htmlspecialchars($topic['subject']).' ['.$topic['o_id'].']';
		$mess .= '<br />- '.$nb_orph_forum.' discussions sans forum';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
	}
	else
	{
		$result = $db->query('DELETE '.$db->prefix.'topics FROM '.$db->prefix.'topics, '.$db->prefix.'orph_topics WHERE o_id=id') or error('Les discussions ne peuvent être supprimées', __FILE__, __LINE__, $db->error());
		$nb_orph_forum = $db->affected_rows($result);
		$mess .= '<br />- '.$nb_orph_forum.' discussions sans forum.';
	}

	return $mess;
}

// Synchronize topic last post
function synchronize_topic_last_post($post = 'posts')
{
	global $db;

	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'topic_last SELECT posted AS n_last_post, id AS n_last_post_id, poster AS n_last_poster, topic_id FROM '.$db->prefix.$post.' ORDER BY posted DESC') or error('Echec de la création de la table des derniers messages', __FILE__, __LINE__, $db->error());
	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'topic_lastb SELECT * FROM '.$db->prefix.'topic_last WHERE topic_id > 0 GROUP BY topic_id') or error('Echec de la création de la table des derniers messages', __FILE__, __LINE__, $db->error());
	if (isset($_POST['test']))
	{
		$result = $db->query('SELECT topic_id, subject FROM '.$db->prefix.'topic_lastb INNER JOIN '.$db->prefix.'topics ON id=topic_id WHERE n_last_post_id!=last_post_id OR n_last_post!=last_post OR n_last_poster!=last_poster') or error('Les derniers messages ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
		$nb_topics = $db->num_rows($result);
		$t = array();
		if (isset($_POST['info']))
			while ($topic = $db->fetch_assoc($result))
				$t[] = pun_htmlspecialchars($topic['subject']).' ['.$topic['topic_id'].']';
		$mess = 'Derniers messages des discussions à synchroniser :<br />- '.$nb_topics.' discussions';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
	}
	else
	{
		$result = $db->query('UPDATE '.$db->prefix.'topics, '.$db->prefix.'topic_lastb SET last_post_id=n_last_post_id, last_post=n_last_post, last_poster=n_last_poster WHERE id=topic_id') or error('Le dernier message ne peut être mis à jour', __FILE__, __LINE__, $db->error());
		$nb_topics = $db->affected_rows($result);
		$mess = 'Derniers messages des discussions synchronisés.<br />- '.$nb_topics.' discussions.';
	}

	return $mess;
}

// Synchronize forum last post
function synchronize_forum_last_post($post = 'posts')
{
	global $db;

	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'forum_last SELECT p.posted AS n_last_post, p.id AS n_last_post_id, p.poster AS n_last_poster, t.forum_id FROM '.$db->prefix.$post.' AS p LEFT JOIN '.$db->prefix.'topics AS t ON p.topic_id=t.id ORDER BY p.posted DESC') or error('Echec de la création de la table des derniers messages', __FILE__, __LINE__, $db->error());
	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'forum_lastb SELECT * FROM '.$db->prefix.'forum_last WHERE forum_id > 0 GROUP BY forum_id') or error('Echec de la création de la table des derniers messages', __FILE__, __LINE__, $db->error());
	$res1 = $db->query('SELECT forum_id, n_last_post_id, n_last_post, n_last_poster FROM '.$db->prefix.'forum_lastb') or error('Les derniers messages ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
	while ($forum = $db->fetch_assoc($res1))
		$new_t[$forum['forum_id']] = array($forum['n_last_post_id'], $forum['n_last_post'], $forum['n_last_poster']);
	$res2 = $db->query('SELECT id, forum_name, last_post_id, last_post, last_poster FROM '.$db->prefix.'forums') or error('Les forums ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
	while ($forum = $db->fetch_assoc($res2))
		$old_t[$forum['id']] = array($forum['last_post_id'], $forum['last_post'], $forum['last_poster'], $forum['forum_name']);
	$nb_forums = 0;
	foreach($old_t as $id => $tab)
		if ((is_array($new_t[$id]) && ($tab[0] != $new_t[$id][0] || $tab[1] != $new_t[$id][1] || $tab[2] != $new_t[$id][2]))
			|| (!is_array($new_t[$id]) && ($tab[0] != '' || $tab[1] != '' || $tab[2] != '')))
		{
			$nb_forums++;
			if (!is_array($new_t[$id]))
				$tonull[] = $id;
			if (isset($_POST['test']) && isset($_POST['info']))
				$t[] = pun_htmlspecialchars($tab[3]).' ['.$id.']';
		}
	if (isset($_POST['test']))
	{
		$mess = 'Derniers messages des forums à synchroniser :<br />- '.$nb_forums.' forums';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
	}
	else
	{
		$result = $db->query('UPDATE '.$db->prefix.'forums, '.$db->prefix.'forum_lastb SET last_post_id=n_last_post_id, last_post=n_last_post, last_poster=n_last_poster WHERE id=forum_id') or error('Le dernier message ne peut être mis à jour', __FILE__, __LINE__, $db->error());
		$nb_forums = $db->affected_rows($result);
		if (count($tonull))
		{
			$result = $db->query('UPDATE '.$db->prefix.'forums SET last_post_id=NULL, last_post=NULL, last_poster=NULL WHERE id IN ('.implode(', ', $tonull).')') or error('Le dernier message ne peut être mis à jour', __FILE__, __LINE__, $db->error());
			$nb_forums += $db->affected_rows($result);
		}
		$mess = 'Derniers messages des forums synchronisés.<br />- '.$nb_forums.' forums.';
	}

	return $mess;
}

// Synchronize topic posts (num replies)
function synchronize_topic_posts($post = 'posts')
{
	global $db;

	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'topic_posts SELECT topic_id, count(*)-1 AS replies FROM '.$db->prefix.$post.' GROUP BY topic_id') or error('Echec de la création de la table des discussions', __FILE__, __LINE__, $db->error());
	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'forum_topics_norm SELECT id AS norm_id FROM '.$db->prefix.'topics') or error('Echec de la création de la table des discussions_forums_norm', __FILE__, __LINE__, $db->error());
	if (isset($_POST['test']))
	{
		$result = $db->query('SELECT topic_id, subject, replies FROM '.$db->prefix.'forum_topics_norm INNER JOIN '.$db->prefix.'topic_posts ON norm_id=topic_id INNER JOIN '.$db->prefix.'topics ON id=topic_id WHERE num_replies!=replies') or error('Les nombres de réponses ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
		$nb_topics = $db->num_rows($result);
		$t = array();
		if (isset($_POST['info']))
			while ($topic = $db->fetch_assoc($result))
				$t[] = pun_htmlspecialchars($topic['subject']).' ['.$topic['topic_id'].' -> '.$topic['replies'].']';
		$mess = 'Nombre de réponses des discussions à synchroniser :<br />- '.$nb_topics.' discussions';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
	}
	else
	{
		$result = $db->query('UPDATE '.$db->prefix.'topics, '.$db->prefix.'forum_topics_norm, '.$db->prefix.'topic_posts SET num_replies=replies WHERE id=topic_id AND id=norm_id') or error('Le nombre de réponses ne peut être mis à jour', __FILE__, __LINE__, $db->error());
		$nb_topics = $db->affected_rows($result);
		$mess = 'Nombre de réponses des discussions synchronisés.<br />- '.$nb_topics.' discussions.';
	}

	return $mess;
}

// Synchronize forum posts (num_posts, num_topics)
function synchronize_forum_posts($post = 'posts')
{
	global $db;

	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'forum_posts SELECT t.forum_id, count(*) AS posts FROM '.$db->prefix.$post.' AS p LEFT JOIN '.$db->prefix.'topics AS t ON p.topic_id=t.id GROUP BY t.forum_id') or error('Echec de la création de la table des messages', __FILE__, __LINE__, $db->error());
	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'forum_topics SELECT forum_id, count(*) AS topics FROM '.$db->prefix.'topics GROUP BY forum_id') or error('Echec de la création de la table des discussions', __FILE__, __LINE__, $db->error());
	$result = $db->query('SELECT forum_id FROM '.$db->prefix.'forum_topics') or error('Echec de la lecture de la table des discussions', __FILE__, __LINE__, $db->error());
	while ($forum = $db->fetch_assoc($result))
		$have_t[] = $forum['forum_id'];
	if (count($have_t))
		$have_topic = ' AND id NOT IN ('.implode(', ', $have_t).')';
	if (isset($_POST['test']))
	{
		$result = $db->query('SELECT forum_id, forum_name FROM '.$db->prefix.'forum_posts INNER JOIN '.$db->prefix.'forums ON id=forum_id WHERE num_posts!=posts') or error('Les nombres de messages ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
		$nb_forums = $db->num_rows($result);
		$t = array();
		if (isset($_POST['info']))
			while ($forum = $db->fetch_assoc($result))
				$t[] = pun_htmlspecialchars($forum['forum_name']).' ['.$forum['forum_id'].']';
		$mess = 'Nombre de messages des forums à synchroniser :<br />- '.$nb_forums.' forums';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
		$result = $db->query('SELECT forum_id, forum_name FROM '.$db->prefix.'forum_topics INNER JOIN '.$db->prefix.'forums ON id=forum_id WHERE num_topics!=topics') or error('Les nombres de discussions ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
		$nb_forums = $db->num_rows($result);
		$t = array();
		if (isset($_POST['info']))
			while ($forum = $db->fetch_assoc($result))
				$t[] = pun_htmlspecialchars($forum['forum_name']).' ['.$forum['forum_id'].']';
		$mess .= '<br /><br />Nombre de discussions des forums à synchroniser :<br />- '.$nb_forums.' forums';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
		$nb_forums = 0;
		$t = array();
		$result = $db->query('SELECT forum_name, num_posts FROM '.$db->prefix.'forums WHERE num_topics!=0'.$have_topic) or error('Les forums à remettre à zéro ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
		while ($forum = $db->fetch_assoc($result))
		{
			if (isset($_POST['info']))
				$t[] = pun_htmlspecialchars($forum['forum_name']).' ['.$forum['num_posts'].' -> 0]';
			$nb_forums++;
		}
		$mess .= '<br /><br />Nombre de forums à remettre à zéro :<br />- '.$nb_forums.' forums';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
	}
	else
	{
		$result = $db->query('UPDATE '.$db->prefix.'forums, '.$db->prefix.'forum_posts SET num_posts=posts WHERE id=forum_id') or error('Le nombre de messages ne peut être mis à jour', __FILE__, __LINE__, $db->error());
		$nb_forums = $db->affected_rows($result);
		$mess = 'Nombre de messages des forums synchronisés :<br />- '.$nb_forums.' forums.';
		$result = $db->query('UPDATE '.$db->prefix.'forums, '.$db->prefix.'forum_topics SET num_topics=topics WHERE id=forum_id') or error('Le nombre de discussions ne peut être mis à jour', __FILE__, __LINE__, $db->error());
		$nb_forums = $db->affected_rows($result);
		$mess .= '<br /><br />Nombre de discussions des forums synchronisés :<br />- '.$nb_forums.' forums.';
		$result = $db->query('UPDATE '.$db->prefix.'forums SET num_topics=0, num_posts=0 WHERE num_topics!=0'.$have_topic) or error('Le nombre de discussions/messages ne peut être remis à zéro', __FILE__, __LINE__, $db->error());
		$nb_forums = $db->affected_rows($result);
		$mess .= '<br /><br />Nombre de forums remis à zéro :<br />- '.$nb_forums.' forums.';
	}

	return $mess;
}

// Synchronize user posts
function synchronize_user_posts()
{
	global $db;

	$db->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.$db->prefix.'user_posts SELECT poster_id, count(*) AS posts FROM '.$db->prefix.'posts GROUP BY poster_id') or error('Echec de la création de la table des messages', __FILE__, __LINE__, $db->error());
	$result = $db->query('SELECT poster_id FROM '.$db->prefix.'user_posts') or error('Echec de la lecture de la table des messages', __FILE__, __LINE__, $db->error());
	while ($user = $db->fetch_assoc($result))
		$have_p[] = $user['poster_id'];
	if (count($have_p))
		$have_post = ' AND id NOT IN ('.implode(', ', $have_p).')';
	if (isset($_POST['test']))
	{
		$result = $db->query('SELECT username, num_posts, posts FROM '.$db->prefix.'user_posts INNER JOIN '.$db->prefix.'users ON id=poster_id WHERE num_posts!=posts') or error('Les nombres de messages ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
		$nb_users = $db->num_rows($result);
		$t = array();
		if (isset($_POST['info']))
			while ($user = $db->fetch_assoc($result))
				$t[] = pun_htmlspecialchars($user['username']).' ['.$user['num_posts'].' -> '.$user['posts'].']';
		$result = $db->query('SELECT username, num_posts FROM '.$db->prefix.'users WHERE num_posts!=0'.$have_post) or error('Les utilisateurs à remettre à zéro ne peuvent être récupérés', __FILE__, __LINE__, $db->error());
		while ($user = $db->fetch_assoc($result))
		{
			if (isset($_POST['info']))
				$t[] = pun_htmlspecialchars($user['username']).' ['.$user['num_posts'].' -> 0]';
			$nb_users++;
		}
		$mess = 'Nombre de messages des utilisateurs à synchroniser :<br />- '.$nb_users.' utilisateurs';
		if (count($t))
			$mess .= ' ('.implode(', ', $t).').';
		else
			$mess .= '.';
	}
	else
	{
		$result = $db->query('UPDATE '.$db->prefix.'users, '.$db->prefix.'user_posts SET num_posts=posts WHERE id=poster_id') or error('Le nombre de messages ne peut être mis à jour', __FILE__, __LINE__, $db->error());
		$nb_users = $db->affected_rows($result);
		$result = $db->query('UPDATE '.$db->prefix.'users SET num_posts=0 WHERE num_posts!=0'.$have_post) or error('Le nombre de messages ne peut être remis à zéro', __FILE__, __LINE__, $db->error());
		$nb_users += $db->affected_rows($result);
		$mess = 'Nombre de messages des utilisateurs synchronisés :<br />- '.$nb_users.' utilisateurs.';
	}

	return $mess;
}

// Regenerate one or several caches
function regen_cache()
{
	global $pun_config;

	$nb_cache = 0;
	require_once PUN_ROOT.'include/cache.php';
	if (isset($_POST['all_cache']) || isset($_POST['config_cache']))
	{
		generate_config_cache();
		$nb_cache++;
	}
	if (isset($_POST['all_cache']) || isset($_POST['qjump_cache']))
	{
		generate_quickjump_cache();
		$nb_cache++;
	}
	if (isset($_POST['all_cache']) || isset($_POST['bans_cache']))
	{
		generate_bans_cache();
		$nb_cache++;
	}
	/*if (isset($_POST['all_cache']) || isset($_POST['ranks_cache']))
	{
		generate_ranks_cache();
		$nb_cache++;
	}*/
	if (isset($_POST['all_cache']) || isset($_POST['toolbar_cache']))
	{
		if (isset($pun_config['o_ptb_installed']) && $pun_config['o_ptb_installed'] == 1)
		{
			require_once PUN_ROOT.'include/cache_puntoolbar.php';
			if ($pun_config['o_ptb_enable_form'] == 1)
				generate_ptb_cache();
			if ($pun_config['o_ptb_enable_quickform'] == 1)
				generate_ptb_cache('quickreply');
			$nb_cache++;
		}
	}
	if (isset($_POST['all_cache']) || isset($_POST['smilies_cache']))
	{
		if (isset($pun_config['o_smilies']) && $pun_config['o_smilies'] == 1)
		{
			require_once PUN_ROOT.'include/cache_smilies.php';
			generate_smiley_cache();
			$nb_cache++;
		}
	}

	if (isset($_POST['all_cache']))
		$mess = 'Tous les caches ont été regénérés.';
	else if ($nb_cache == 1)
		$mess = 'Le cache a été regénéré.';
	else
		$mess = $nb_cache.' caches ont été regénérés.';
	return $mess;
}

// Submitted
if (isset($_POST['action']))
{
	$error = false;
	switch($_POST['action'])
	{
		case 'cleanup' :
			$mess_total = cleanup_spam();
			break;
		case 'delete_orphans' :
			$mess_total = clear_orphans();
			break;
		case 'topic_last_post' :
			$mess_total = synchronize_topic_last_post();
			break;
		case 'forum_last_post' :
			$mess_total = synchronize_forum_last_post();
			break;
		case 'topic_post_sync' :
			$mess_total = synchronize_topic_posts();
			break;
		case 'forum_post_sync' :
			$mess_total = synchronize_forum_posts();
			break;
		case 'user_post_sync' :
			$mess_total = synchronize_user_posts();
			break;
		case 'cache_sync' :
			$mess_total = regen_cache();
			break;
		default :
			$mess_total = $lang_common['Bad request'];
			$error = true;
	}

	if (isset($_POST['test']) || $error)
		message($mess_total);
	else
		redirect($_SERVER['REQUEST_URI'], $mess_total);
}

// Display form
else
{
	generate_admin_menu($plugin);
	$mysql_version = $db->query('SELECT VERSION()');
	if (version_compare($db->result($mysql_version), "4.0.4", ">"))
	{
?>
	<div class="plugin blockform">
		<h2><span>Nettoyage de forums - v<?php echo PLUGIN_VERSION ?></span></h2>
		<div class="box">
			<div class="inbox">
				<p>Ce plugin est utile pour nettoyer le désordre fait par les spammeurs, ainsi que les modifications <strong>manuelles</strong> de la base de données qui ont tout mis sens dessus dessous.</p>
			</div>
		</div>
		<h2 class="block2"><span>Nettoyage complet de spam</span></h2>
		<div class="box">
			<div class="inbox">
			<p>Ce dispositif est prévu pour nettoyer le désordre après une attaque de spammeurs.<br />Il fonctionne ainsi : vous entrez une ou plusieurs adresses IP (séparées par les espaces) ci-dessous, et il supprime tous les utilisateurs et les messages qui ont été postés avec cette IP.<br />Il effectue ensuite le reste des opérations de nettoyage (sauf le nombre de messages des utilisateurs, puisque ce n'est pas forcément désiré).</p>
				<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
					<div class="inform">
						<fieldset>
							<legend>Adresses IP à traiter</legend>
								<div class="infldset">
									<p>Entrer une liste d'une ou plusieurs adresses IP à supprimer du forum, séparées par des espaces (notez qu'il vous est recommandé également d'interdire ces adresses IP dans la section "Bannissements" de l'administration).<br /><span class="bbu">Note</span> : ne pas spécifier d'IP permet de lancer toutes les opérations de nettoyage en une seule fois.</p>
									<input type="text" name="ip_addys" size="50" maxlength="255" />
									<div class="inbox rbox conl">
										<label><input type="checkbox" name="test" value="1" />Tester seulement</label>
										<label><input type="checkbox" name="info" value="1" />Afficher infos</label>
									</div>
								</div>
						</fieldset>
					</div>
					<p><input type="hidden" name="action" value="cleanup" /><input type="submit" value="Nettoyer" tabindex="1" /></p>
				</form>
			</div>
		</div>
		<h2 class="block2"><span>Supprimer les orphelins</span></h2>
		<div class="box">
			<div class="inbox">
			<p>Ce dispositif supprime tous les messages dont la discussion a été supprimée, et inversement toutes les discussions qui n'ont aucun message, ainsi que toutes les discussions dont le forum a été supprimé. Utile après modification de la base de données.</p>
				<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
					<div class="inform">
						<fieldset>
							<div class="infldset">
								<div class="inbox rbox conl">
									<label><input type="checkbox" name="test" value="1" />Tester seulement</label>
									<label><input type="checkbox" name="info" value="1" />Afficher infos</label>
								</div>
							</div>
						</fieldset>
					</div>
					<p><input type="hidden" name="action" value="delete_orphans" /><input type="submit" value="Supprimer" tabindex="2" /></p>
				</form>
			</div>
		</div>
		<h2 class="block2"><span>Synchroniser le dernier message des discussions</span></h2>
		<div class="box">
			<div class="inbox">
			<p>Ce dispositif met à jour la section "dernier message" de chaque discussion. Utile pour nettoyer le désordre après une attaque de spammmeurs  ou une édition de la base de données.</p>
				<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
					<div class="inform">
						<fieldset>
							<div class="infldset">
								<div class="inbox rbox conl">
									<label><input type="checkbox" name="test" value="1" />Tester seulement</label>
									<label><input type="checkbox" name="info" value="1" />Afficher infos</label>
								</div>
							</div>
						</fieldset>
					</div>
					<p><input type="hidden" name="action" value="topic_last_post" /><input type="submit" value="Synchroniser" tabindex="3" /></p>
				</form>
			</div>
		</div>
		<h2 class="block2"><span>Synchroniser le dernier message des forums</span></h2>
		<div class="box">
			<div class="inbox">
			<p>Ce dispositif met à jour la section "dernier message" de chaque forum. Utile pour nettoyer le désordre après une attaque de spammeurs  ou une édition de la base de données.</p>
				<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
					<div class="inform">
						<fieldset>
							<div class="infldset">
								<div class="inbox rbox conl">
									<label><input type="checkbox" name="test" value="1" />Tester seulement</label>
									<label><input type="checkbox" name="info" value="1" />Afficher infos</label>
								</div>
							</div>
						</fieldset>
					</div>
					<p><input type="hidden" name="action" value="forum_last_post" /><input type="submit" value="Synchroniser" tabindex="4" /></p>
				</form>
			</div>
		</div>
		<h2 class="block2"><span>Synchroniser le nombre de réponses des discussions</span></h2>
		<div class="box">
			<div class="inbox">
			<p>Ce dispositif établit le nombre de réponses que chaque discussion a actuellement et met à jour leur nombre de réponses. Utile si vous avez modifié la base de données.</p>
				<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
					<div class="inform">
						<fieldset>
							<div class="infldset">
								<div class="inbox rbox conl">
									<label><input type="checkbox" name="test" value="1" />Tester seulement</label>
									<label><input type="checkbox" name="info" value="1" />Afficher infos</label>
								</div>
							</div>
						</fieldset>
					</div>
					<p><input type="hidden" name="action" value="topic_post_sync" /><input type="submit" value="Synchroniser" tabindex="5" /></p>
				</form>
			</div>
		</div>
		<h2 class="block2"><span>Synchroniser le nombre de messages/discussions des forums</span></h2>
		<div class="box">
			<div class="inbox">
			<p>Ce dispositif établit le nombre de messages/discussions que chaque forum a actuellement et met à jour leur nombre de messages/discussions. Utile si vous avez modifié la base de données.</p>
				<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
					<div class="inform">
						<fieldset>
							<div class="infldset">
								<div class="inbox rbox conl">
									<label><input type="checkbox" name="test" value="1" />Tester seulement</label>
									<label><input type="checkbox" name="info" value="1" />Afficher infos</label>
								</div>
							</div>
						</fieldset>
					</div>
					<p><input type="hidden" name="action" value="forum_post_sync" /><input type="submit" value="Synchroniser" tabindex="6" /></p>
				</form>
			</div>
		</div>
		<h2 class="block2"><span>Synchroniser le nombre de messages des utilisateurs</span></h2>
		<div class="box">
			<div class="inbox">
			<p>Ce dispositif établit le nombre de messages que chaque utilisateur a actuellement et met à jour leur nombre de messages. Utile si vous avez supprimé beaucoup de messages et voulez synchroniser le nombre de messages des utilisateurs.<br /><span class="bbu">Rappel</span> : le fonctionnement normal est de considérer le nombre de messages comme étant le nombre des "postés", sans tenir compte des éventuelles suppressions.</p>
				<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
					<div class="inform">
						<fieldset>
							<div class="infldset">
								<div class="inbox rbox conl">
									<label><input type="checkbox" name="test" value="1" />Tester seulement</label>
									<label><input type="checkbox" name="info" value="1" />Afficher infos</label>
								</div>
							</div>
						</fieldset>
					</div>
					<p><input type="hidden" name="action" value="user_post_sync" /><input type="submit" value="Synchroniser" tabindex="7" /></p>
				</form>
			</div>
		</div>
		<h2 class="block2"><span>Reconstruire un ou plusieurs fichiers de cache</span></h2>
		<div class="box">
			<div class="inbox">
			<p>Ce dispositif permet de reconstruire les fichiers de cache utilisés par FluxBB. Utile si vous avez modifié certaines valeurs de configuration directement dans la base de données.</p>
				<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
					<div class="inform">
						<fieldset>
							<div class="infldset">
								<div class="inbox rbox conl">
									<label><input type="checkbox" name="all_cache" value="1" />Tous les caches</label>
									<br /><label><input type="checkbox" name="config_cache" value="1" />Cache de configuration</label>
									<label><input type="checkbox" name="qjump_cache" value="1" />Caches de saut rapide</label>
									<label><input type="checkbox" name="bans_cache" value="1" />Cache des bannissements</label>
									<!-- <label><input type="checkbox" name="ranks_cache" value="1" />Cache des rangs</label> -->
								</div>
							</div>
						</fieldset>
					</div>
					<p><input type="hidden" name="action" value="cache_sync" /><input type="submit" value="Reconstruire" tabindex="8" /></p>
				</form>
			</div>
		</div>
	</div>
<?php
	}
	else
		message('Désolé, ce script exige Mysql 4.0.4 ou ulterieur.');
}
?>