<?php
/***********************************************************************

  Copyright (C) 2013 Otomatic
  License: http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  Plugin: Toggle Debug Mode and Display Queries ON/OFF
  Version: 1.2 - June 03 2013
  
  Choice made to modify : 
  - include/common.php in order to allow
  DEBUG and/or SHOW QUERIES modes only for admin's
  - config.php in order to allow
  DEBUG and/or SHOW QUERIES modes for all queries

************************************************************************/

// Make sure no one attempts to run this script "directly"
if (!defined('PUN')) exit;

// Tell admin_loader.php that this is indeed a plugin and that it is loaded
define('PUN_PLUGIN_LOADED', 1);
// Define version number and date
define('TOGGLE_DEBUG', 'Version: 1.2 - June 03, 2013 - © Otomatic');

//******************************************************
//*** Uninstall version 1.0 if it had been installed ***
$file_to_uninstall = 'include/common.php';
if(is_readable(PUN_ROOT.$file_to_uninstall) && is_writable(PUN_ROOT.$file_to_uninstall))
{
	$verify_string = "//DO NOT MODIFY THIS LINE - TOGGLE DEBUG MODE INSTALLED";
	$file_content = file_get_contents(PUN_ROOT.$file_to_uninstall);
	if(strpos($file_content, $verify_string) !== false)
	{
		get_modes($file_to_uninstall);
		if($debug_mode) set_debug_mode($file_to_uninstall, false);
		if($queries_mode) set_queries_mode($file_to_uninstall, false);
		$file_content = file_get_contents(PUN_ROOT.$file_to_uninstall);
		$search_string = "//[modif oto] Adding debugging constants\n//DO NOT MODIFY THIS LINE - TOGGLE DEBUG MODE INSTALLED\n//Do not activate any of these modes in a production environment!\nif (\$pun_user['g_id'] == PUN_ADMIN)\n{\n//define('PUN_DEBUG', 1); //DO NOT MODIFY THIS LINE\n//define('PUN_SHOW_QUERIES', 1); //DO NOT MODIFY THIS LINE\n}\n";
		$file_content = str_replace($search_string, "", $file_content);
		file_put_contents(PUN_ROOT.$file_to_uninstall, $file_content);
	}
}
//******************************************************

//*** Function to update files *************************
function update_file($file_to_update,$from_ver, $to_ver) {
	if(is_readable(PUN_ROOT.$file_to_update) && is_writable(PUN_ROOT.$file_to_update))
	{
		$verify_string = "//DO NOT MODIFY THIS LINE - TOGGLE DEBUG MODE ".$from_ver." INSTALLED";
		$update_string = "//DO NOT MODIFY THIS LINE - TOGGLE DEBUG MODE ".$to_ver." INSTALLED";
		$file_content = file_get_contents(PUN_ROOT.$file_to_update);
		if(strpos($file_content, $verify_string) !== false)
		{
			$file_content = str_replace($verify_string, $update_string, $file_content);
			file_put_contents(PUN_ROOT.$file_to_update, $file_content);
		}
	}
}
//**** Update version 1.1 if it had been installed *****
update_file('include/common.php',"V1.1", "V1.2");
update_file('config.php',"V1.1", "V1.2");
//******************************************************

// Load the Toggle Debug Mode language files
if (file_exists(PUN_ROOT.'lang/'.$pun_user['language'].'/toggle_debug_mode.php'))
	require PUN_ROOT.'lang/'.$pun_user['language'].'/toggle_debug_mode.php';
else
	require PUN_ROOT.'lang/English/toggle_debug_mode.php';

$verify_string = "//DO NOT MODIFY THIS LINE - TOGGLE DEBUG MODE V1.2 INSTALLED";
$erreur = array();
$debug_mode_config = $debug_mode_common = $queries_mode_config = $queries_mode_common = false;

function verify_install_in_file($file, $search, $replace) {
	global $file_name, $file_to_test, $file_readable, $file_writable, $verify_string, $plugin_installed, $debug_mode, $queries_mode;
	
	$file_name = $file;
	$file_to_test = PUN_ROOT.$file_name;
	$file_readable = $file_writable = $plugin_installed = $debug_mode = $queries_mode = false;
	//Is file prepared for DEBUG and SHOW QUERIES?
	if(is_readable($file_to_test) === true) $file_readable = true;
	else return false;
	if(is_writable($file_to_test) === true) $file_writable = true;
	else return false;
	
	//File must be readable and writable
	$file_content = file_get_contents($file_to_test);
	
	//Verification if Toggle Debug Mode is already installed
	if(strpos($file_content,$verify_string) === false)
	{	//Toggle Debug Mode not installed
		//Verify and suppress already existing line with constants PUN_DEBUG or PUN_SHOW_QUERIES
		if(strpos($file_content,"PUN_DEBUG") !== false)
		{//Suppress line with PUN_DEBUG
			$lignes = file($file_to_test,FILE_IGNORE_NEW_LINES);
			foreach($lignes as $key => $value)
				if(strpos($value,"PUN_DEBUG") !== false) break;
				$file_content = str_replace($lignes[$key], "", $file_content);
				unset($lignes);
		}
		if(strpos($file_content,"PUN_SHOW_QUERIES") !== false)
		{//Suppress line with PUN_SHOW_QUERIES
			$lignes = file($file_to_test,FILE_IGNORE_NEW_LINES);
			foreach($lignes as $key => $value)
				if(strpos($value,"PUN_SHOW_QUERIES") !== false) break;
				$file_content = str_replace($lignes[$key], "", $file_content);
				unset ($lignes);
		}
		
		//Add possibilities to active DEBUG and SHOW QUERIES modes in file
		$file_content = str_replace($search, $replace, $file_content);
		file_put_contents($file_to_test, $file_content);
	}
	
	//Test if DEBUG and SHOW QUERIES modes are installed
	if(strpos($file_content,$verify_string) === false) {
		$plugin_installed = false;
		return false;
	}
	else $plugin_installed = true;
}

//Function to get the state of modes
function get_modes($file) {
	global $file_name, $file_to_test, $debug_mode, $queries_mode;
	$file_name = $file;
	$file_to_test = PUN_ROOT.$file_name;
	$file_content = file_get_contents($file_to_test);
	
	//Test if DEBUG and SHOW QUERIES modes are ON or OFF
	if(strpos($file_content,"//define('PUN_DEBUG'") !== false)	$debug_mode = false;
	else $debug_mode = true;
	if(strpos($file_content,"//define('PUN_SHOW_QUERIES'") !== false) $queries_mode = false;
	else $queries_mode = true;
}

//Function to set DEBUG mode to ON or OFF
function set_debug_mode($file, $mode=false) {
	global $file_name, $file_to_test, $debug_mode;
	$file_name = $file;
	$file_to_test = PUN_ROOT.$file_name;
	$file_content = file_get_contents($file_to_test);
	if($mode)
	{
		//Enable debug mode
		$file_content = str_replace("//define('PUN_DEBUG'","define('PUN_DEBUG'",$file_content);
		file_put_contents($file_to_test, $file_content);
		$debug_mode = true;
	}
	else
	{
		//Disable debug mode
		if(strpos($file_content, "//define('PUN_DEBUG'") === false) 
		{
			$file_content = str_replace("define('PUN_DEBUG'","//define('PUN_DEBUG'",$file_content);
			file_put_contents($file_to_test, $file_content);
		}
		$debug_mode = false;
	}
}

//Function to set SHOW QUERIES mode to ON or OFF
function set_queries_mode($file, $mode=false) {
	global $file_name, $file_to_test, $queries_mode;
	$file_name = $file;
	$file_to_test = PUN_ROOT.$file_name;
	$file_content = file_get_contents($file_to_test);
	if($mode)
	{
		//Enable queries mode
		$file_content = str_replace("//define('PUN_SHOW_QUERIES'","define('PUN_SHOW_QUERIES'",$file_content);
		file_put_contents($file_to_test, $file_content);
		$queries_mode = true;
	}
	else
	{
		//Disable queries mode
		if(strpos($file_content, "//define('PUN_SHOW_QUERIES'") === false)
		{
			$file_content = str_replace("define('PUN_SHOW_QUERIES'","//define('PUN_SHOW_QUERIES'",$file_content);
			file_put_contents($file_to_test, $file_content);
		}
		$queries_mode = false;
	}
}
//Function to verify that only one file is activated for each mode (Priority to config.php)
function only_one_file() {
	global $debug_mode_config, $debug_mode_common, $queries_mode_config, $queries_mode_common;
	if($debug_mode_config && $debug_mode_common) {
		set_debug_mode('include/common.php',false);
		$debug_mode_common = false;
	}
	if($queries_mode_config && $queries_mode_common) {
		set_queries_mode('include/common.php',false);
		$queries_mode_common = false;
	}
	if($debug_mode_config && $queries_mode_common) {
		set_queries_mode('include/common.php',false);
		$queries_mode_common = false;
	}
	if($queries_mode_config && $debug_mode_common) {
		set_debug_mode('include/common.php',false);
		$debug_mode_common = false;
	}
}
//What mode are set and what file? (default: config.php)
function what_mode() {
	global $debug_mode_config, $debug_mode_common, $queries_mode_config, $queries_mode_common, $debug_mode, $queries_mode, $file_set_common, $file_set_config; 
	if($debug_mode_config || $debug_mode_common)
		$debug_mode = true;
	else
		$debug_mode = false;
	if($queries_mode_config || $queries_mode_common)
		$queries_mode = true;
	else
		$queries_mode = false;
		
	$file_set_config = true;
	$file_set_common = false;
	if($debug_mode_common || $queries_mode_common)
	{
		$file_set_common = true;
		$file_set_config = false;
	}
}
//--- end of functions ---

//Verify DEBUG and SHOW QUERIES constants are installed for admin only (include/common.php)
$file = "include/common.php";
$search = "update_users_online();\n";
$replace = "update_users_online();\n//[modif oto] Adding debugging constants\n".$verify_string."\n//Do not activate any of these modes in a production environment!\nif (\$pun_user['g_id'] == PUN_ADMIN)\n{\n\tif(!defined('PUN_DEBUG')) {\n\t//define('PUN_DEBUG', 1); //DO NOT MODIFY THIS LINE\n\t}\n\tif(!defined('PUN_SHOW_QUERIES')) {\n\t//define('PUN_SHOW_QUERIES', 1); //DO NOT MODIFY THIS LINE\n\t}\n}\n";
if(verify_install_in_file($file, $search, $replace) === false)
{
	if(!$plugin_installed)
  	$erreur[] = sprintf($lang_toggle['file_not_installed'],$file_name);
  if(!$file_readable)
    $erreur[] = sprintf($lang_toggle['file_not_readable'],$file_name);
  if(!$file_writable)
    $erreur[] = sprintf($lang_toggle['file_not_writable'],$file_name);
  $erreur[] = sprintf($lang_toggle['file_access'],$file_name);
}
else
{
	get_modes($file);
	$debug_mode_common = $debug_mode;
	$queries_mode_common = $queries_mode;
}

//Verify DEBUG and SHOW QUERIES constants are installed for all (config.php)
$file = "config.php";
$search = "define('PUN', 1);\n";
$replace = "define('PUN', 1);\n//[modif oto] Adding debugging constants\n".$verify_string."\n//Do not activate any of these modes in a production environment!\n//define('PUN_DEBUG', 1); //DO NOT MODIFY THIS LINE\n//define('PUN_SHOW_QUERIES', 1); //DO NOT MODIFY THIS LINE\n";
if(verify_install_in_file($file, $search, $replace) === false)
{
	if(!$plugin_installed)
  	$erreur[] = sprintf($lang_toggle['file_not_installed'],$file_name);
  if(!$file_readable)
    $erreur[] = sprintf($lang_toggle['file_not_readable'],$file_name);
  if(!$file_writable)
    $erreur[] = sprintf($lang_toggle['file_not_writable'],$file_name);
  $erreur[] = sprintf($lang_toggle['file_access'],$file_name);
}
else
{
	get_modes($file);
	$debug_mode_config = $debug_mode;
	$queries_mode_config = $queries_mode;
}

if(count($erreur) == 0)
{
	only_one_file();
	what_mode();
}
	
// Confirm Page
if (isset($_POST['confirm']) && isset($_POST['form_sent']) && count($erreur) == 0)
{
	if($_POST['what_file'] == 'config')
	{
		$file_to_set = 'config.php';
		$file_to_reset = 'include/common.php';
	}
	else
	{
		$file_to_set = 'include/common.php';
		$file_to_reset = 'config.php';
	}

	if(isset($_POST['mode_debug']))
	{
		if($_POST['mode_debug'] == "yes")
		{//Enable debug mode
			set_debug_mode($file_to_set,true);
			set_debug_mode($file_to_reset, false);
		}
		elseif($_POST['mode_debug'] == "no")
		{//Disable debug mode
			set_debug_mode($file_to_set, false);
			set_debug_mode($file_to_reset, false);
		}
	}
	if(isset($_POST['mode_queries']))
	{
		if($_POST['mode_queries'] == "yes")
		{//Enable queries mode
			set_queries_mode($file_to_set, true);
			set_queries_mode($file_to_reset, false);
		}
		elseif($_POST['mode_queries'] == "no")
		{//Disable queries mode
			set_queries_mode($file_to_set, false);
			set_queries_mode($file_to_reset, false);
		}
	}
	get_modes('include/common.php');
	$debug_mode_common = $debug_mode;
	$queries_mode_common = $queries_mode;
	get_modes('config.php');
	$debug_mode_config = $debug_mode;
	$queries_mode_config = $queries_mode;
	only_one_file();
	what_mode();
}

// Display the admin navigation menu
generate_admin_menu($plugin);

?>
<div id="toggle_mode_plugin" class="blockform">
  <h2><span>Toggle Debug Mode - <?php echo TOGGLE_DEBUG ?></span></h2>
  <div class="box">
    <div class="inbox">
      <p><?php echo $lang_toggle['title'] ?></p>
      <p><?php echo $lang_toggle['description'] ?></p>
    </div>
  </div>
  <div class="box">
  	<?php	if(count($erreur) == 0) { ?>
    <form id="toggle_debug" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
			<div class="inform">
				<input type="hidden" name="form_sent" value="1" />
				<fieldset>
					<legend><?php echo $lang_toggle['choice'] ?></legend>
					<div class="infldset">
        		<table class="alingtop" cellspacing="0">
        			<tr><th scope="row"><?php echo $lang_toggle['debug_mode'] ?></th><th scope="row"><?php echo ($debug_mode ? $lang_toggle['enabled'] : $lang_toggle['disabled']) ?></th><td style='width:40%;'><label class="conl"><input type="radio" name="mode_debug" value="yes" <?php echo ($debug_mode ? "checked='checked'" : "") ?> /><?php echo $lang_toggle['enable'] ?></label><label class="conl"><input type="radio" name="mode_debug" value="no" <?php echo (!$debug_mode ? "checked='checked'" : "") ?> /><?php echo $lang_toggle['disable'] ?></label></td></tr>
        			<tr><th scope="row"><?php echo $lang_toggle['queries_mode'] ?></th><th scope="row"><?php echo ($queries_mode ? $lang_toggle['enabled'] : $lang_toggle['disabled']) ?></th><td><label class="conl"><input type="radio" name="mode_queries" value="yes" <?php echo ($queries_mode ? "checked='checked'" : "") ?> /><?php echo $lang_toggle['enable'] ?></label><label class="conl"><input type="radio" name="mode_queries" value="no" <?php echo (!$queries_mode ? "checked='checked'" : "") ?> /><?php echo $lang_toggle['disable'] ?></label></td></tr>
        		</table>
    			</div>
    		</fieldset>
    	</div>
			<div class="inform">
				<fieldset>
					<legend><?php echo $lang_toggle['how_enable'] ?></legend>
					<div class="infldset">
      			<table class="alingtop" cellspacing="0">
      				<tr><th scope="row"><?php echo $lang_toggle['how_use'] ?></th><td style='width:75%;'><label class="conl"><input type="radio" name="what_file" value="config" <?php echo ($file_set_config ? "checked='checked'" : "") ?> /><?php echo $lang_toggle['for_all'] ?></label><label class="conl"><input type="radio" name="what_file" value="common" <?php echo ($file_set_common ? "checked='checked'" : "") ?> /><?php echo $lang_toggle['for_admin'] ?></label><span><?php echo $lang_toggle['how_explain'] ?></span></td></tr>
      			</table>
      		</div>
      	</fieldset>
      </div>
    	<p class="submitend"><input type="submit" name="confirm" value="<?php echo $lang_toggle['submit'] ?>" tabindex="3" /></p>
    </form>
    <?php
    }
    else {
    	echo "<div style='padding:5px;'>\n";
    	for($i = 0 ; $i < count($erreur) ; $i++)
    		echo "<p>".$erreur[$i]."</p>\n";
    	echo "</div>\n";
    }; ?>
  </div>
</div>
<?php

// --------------------------------------------------------------------

// Note that the script just ends here. The footer will be included by admin_loader.php.
 